{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
unit Unit1;

interface

{$IFDEF KOL_MCK}
uses Windows, Messages, ShellAPI, KOL {$IFNDEF KOL_MCK}, mirror, Classes,
  Controls, mckCtrls, mckObjs {$ENDIF}, UnitRobot{, err};
{$ELSE}
{$I uses.inc}
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs;
{$ENDIF}

type
  {$IFDEF KOL_MCK}
  {$I MCKfakeClasses.inc}
  PForm1 = ^TForm1;
  TForm1 = object(TObj)
    Form: PControl;
  {$ELSE not_KOL_MCK}
  TForm1 = class(TForm)
  {$ENDIF KOL_MCK}
    KOLProject1: TKOLProject;
    KOLForm1: TKOLForm;
    Panel1: TKOLPanel;
    ComboBox1: TKOLComboBox;
    Label1: TKOLLabel;
    Label2: TKOLLabel;
    ComboBox2: TKOLComboBox;
    Label3: TKOLLabel;
    ComboBox3: TKOLComboBox;
    Label4: TKOLLabel;
    ComboBox4: TKOLComboBox;
    Button1: TKOLButton;
    Button2: TKOLButton;
    Button3: TKOLButton;
    Button4: TKOLButton;
    Button5: TKOLButton;
    Panel7: TKOLPanel;
    Button6: TKOLButton;
    PaintBox1: TKOLPaintBox;
    OpenDirDialog1: TKOLOpenDirDialog;
    Timer1: TKOLTimer;
    btStart: TKOLButton;
    btPause: TKOLButton;
    btStep: TKOLButton;
    btRun: TKOLButton;
    lbDebug1: TKOLLabel;
    lbDebug2: TKOLLabel;
    lbDebug3: TKOLLabel;
    lbDebug4: TKOLLabel;
    lbDebug5: TKOLLabel;
    lbDebug6: TKOLLabel;
    lbDebug7: TKOLLabel;
    Panel3: TKOLPanel;
    lbCount1: TKOLLabel;
    Panel4: TKOLPanel;
    lbCount2: TKOLLabel;
    Panel5: TKOLPanel;
    lbCount3: TKOLLabel;
    Panel6: TKOLPanel;
    lbCount4: TKOLLabel;
    Panel8: TKOLPanel;
    RadioBox1: TKOLRadioBox;
    RadioBox2: TKOLRadioBox;
    RadioBox3: TKOLRadioBox;
    lbStep: TKOLLabel;
    lbDbgX: TKOLLabel;
    lbDbgY: TKOLLabel;
    lbDbgZ: TKOLLabel;
    lbDbgE: TKOLLabel;
    lbDbgD: TKOLLabel;
    lbDbgN: TKOLLabel;
    lbDead1: TKOLLabel;
    lbDead2: TKOLLabel;
    lbDead3: TKOLLabel;
    lbDead4: TKOLLabel;
    lbDbgM: TKOLLabel;
    cbSize: TKOLComboBox;
    Label5: TKOLLabel;
    BitBtn1: TKOLBitBtn;
    procedure KOLForm1FormCreate(Sender: PObj);
    procedure Button6Click(Sender: PObj);
    procedure Button1Click(Sender: PObj);
    procedure Button5Click(Sender: PObj);
    procedure ComboBox1Change(Sender: PObj);
    procedure btStartClick(Sender: PObj);
    procedure KOLForm1Destroy(Sender: PObj);
    procedure Timer1Timer(Sender: PObj);
    procedure PaintBox1Paint(Sender: PControl; DC: HDC);
    procedure RadioBox1Click(Sender: PObj);
    procedure PaintBox1Click(Sender: PObj);
    procedure btPauseClick(Sender: PObj);
    procedure btStepClick(Sender: PObj);
    procedure btRunClick(Sender: PObj);
    procedure KOLForm1Close(Sender: PObj; var Accept: Boolean);
    procedure BitBtn1Click(Sender: PObj);
  private
    { Private declarations }
    ArmyProg: array[ 1..4 ] of PStrList;
    Sprites: array[ 1..4, TDirection ] of PBitmap;
    BummIco: PIcon;
    procedure Init_Sprites;
    procedure Clear;
    procedure AddCommandToDebugWnd( S: PChar; R: PRobot );
  public
    { Public declarations }
    Step: Integer;
    DebugRobot: PRobot;
    DeadCount: array[ 1..4 ] of Integer;
    procedure Fill_Combos( Preserve: Boolean = FALSE );
    function ValidRobotFiles: Integer;
    procedure War;
  end;

var
  Form1 {$IFDEF KOL_MCK} : PForm1 {$ELSE} : TForm1 {$ENDIF} ;

{$IFDEF KOL_MCK}
procedure NewForm1( var Result: PForm1; AParent: PControl );
{$ENDIF}

{$R ROBOTS.res}

implementation

{$IFNDEF KOL_MCK} {$R *.DFM} {$ENDIF}

{$IFDEF KOL_MCK}
{$I Unit1_1.inc}
{$ENDIF}

procedure TForm1.KOLForm1FormCreate(Sender: PObj);
begin
  OpenDirDialog1.InitialPath := GetStartDir;
  Fill_Combos;
  Init_Sprites;
  Applet.Icon := BummIco.Handle;
end;

procedure TForm1.Button6Click(Sender: PObj);
var S: String;
begin
  S := OpenDirDialog1.InitialPath;
  ShellExecute( 0, nil, PChar( S ), nil, nil, SW_SHOW );
  {if OpenDirDialog1.Execute then
  begin
    if S <> OpenDirDialog1.Path then
    begin
      OpenDirDialog1.InitialPath := OpenDirDialog1.Path;
      Fill_Combos;
    end;
  end;}
end;

procedure TForm1.Fill_Combos( Preserve: Boolean = FALSE );
var DL: PDirList;
  procedure FillCombo( Combo: PControl );
  var I: Integer;
      S: String;
  begin
    S := '';
    if Preserve and (Combo.CurIndex >= 0) then
      S := Combo.Items[ Combo.CurIndex ];
    Combo.Clear;
    for I := 0 to DL.Count-1 do
      Combo.Add( DL.Names[ I ] );
    if Preserve then
      Combo.CurIndex := Combo.Perform( CB_FINDSTRINGEXACT, 0, Integer( PChar( S ) ) )
    else
      Combo.CurIndex := -1;
  end;
begin
  DL := NewDirListEx( OpenDirDialog1.InitialPath, '*.rob', FILE_ATTRIBUTE_NORMAL );
  DL.Sort( [ ] );
  FillCombo( ComboBox1 );
  FillCombo( ComboBox2 );
  FillCombo( ComboBox3 );
  FillCombo( ComboBox4 );
  DL.Free;
end;

procedure TForm1.Button1Click(Sender: PObj);
var Combo: PControl;
    SL: PStrList;
    S: String;
begin
  CASE Sender.Tag OF
  1: Combo := ComboBox1;
  2: Combo := ComboBox2;
  3: Combo := ComboBox3;
  4: Combo := ComboBox4;
  else Exit;
  END;
  if Combo.Caption = '' then Exit;
  S := Combo.Caption;
  if ExtractFileExt( S ) <> '.rob' then
  begin
    S := ReplaceFileExt( S, '.rob' );
    Combo.Caption := S;
  end;
  if not FileExists( OpenDirDialog1.InitialPath + S ) then
  begin
    SL := NewStrList;
    SL.SaveToFile( OpenDirDialog1.InitialPath + S );
    SL.Free;
  end;
  if Combo.Perform(CB_FINDSTRINGEXACT, 0, Integer( PChar( S ) )) < 0 then
  begin
    Combo.Insert( 0, S );
    Combo.CurIndex := 0;
  end;
  Fill_Combos( TRUE );
  ShellExecute( 0, nil, 'notepad.exe', PChar( OpenDirDialog1.InitialPath + S ), nil, SW_SHOW );
end;

procedure TForm1.Button5Click(Sender: PObj);
begin
  if OpenDirDialog1.Execute then
  begin
    OpenDirDialog1.InitialPath := OpenDirDialog1.Path;
    Fill_Combos;
  end;
end;

procedure TForm1.ComboBox1Change(Sender: PObj);
var Bt: PControl;
begin
  CASE Sender.Tag OF
  1: Bt := Button1;
  2: Bt := Button2;
  3: Bt := Button3;
  4: Bt := Button4;
  else Exit;
  END;
  Bt.Enabled := PControl( Sender ).Caption <> '';
  btStart.Enabled := ValidRobotFiles > 0;
end;

function TForm1.ValidRobotFiles: Integer;
  procedure Chk( C: PControl );
  begin
    if C.Caption <> '' then
    if FileExists( OpenDirDialog1.InitialPath + C.Caption ) then
      Inc( Result );
  end;
begin
  Result := 0;
  Chk( ComboBox1 );
  Chk( ComboBox2 );
  Chk( ComboBox3 );
  Chk( ComboBox4 );
end;

procedure TForm1.btStartClick(Sender: PObj);
begin
  if btStart.Tag = 0 then
  begin
    if ValidRobotFiles < 1 then
    begin
      ShowMessage( 'Sorry, not all robots are valid. Start impossible.' );
      Exit;
    end;
    btStart.Caption := 'Stop';
    btStart.Tag := 1;
    btPause.Enabled := TRUE;
    CASE cbSize.CurIndex OF
    0: MaxX := 40;
    1: MAxX := 30;
    2: MaxX := 20;
    3: MaxX := 15;
    4: MaxX := 10;
    END;
    MAxY := MaxX;
    War;
  end
    else
  begin
    btStart.Tag := 0;
    btStart.Caption := 'Start War';
    Timer1.Enabled := FALSE;
    btPause.Enabled := FALSE;
    btStep.Enabled := FALSE;
    btRun.Enabled := FALSE;
  end;
end;

procedure TForm1.War;
  procedure Prepare( Army: Integer; Combo: PControl );
  const IniPos: array[ 1..4 ] of TPoint = (( X: 1; Y: 1 ), (X: 3; Y: 1),
                                           ( X: 1; Y: 3 ), (X: 3; Y: 3) ) ;
        IniDir: array[ 1..4 ] of TDirection = ( d_Right, d_Bottom, d_Top, d_Left );
  var R: PRobot;
      P: TPoint;
  begin
    if FileExists( OpenDirDialog1.InitialPath + Combo.Caption ) then
    begin
      ArmyProg[ Army ] := NewStrList;
      ArmyProg[ Army ].LoadFromFile( OpenDirDialog1.InitialPath + Combo.Caption );
      new( R, Create );
      R.Army := Army;
      R.ProgramText := ArmyProg[ Army ];
      P := IniPos[ Army ];
      P.X := P.X * MaxX div 4;
      P.Y := P.Y * MaxY div 4;
      Desk[ P.X, P.Y ] := R;
      R.Direction := IniDir[ Army ];
      R.Energy := 100;
    end;
  end;
var I: Integer;
begin
  Clear;
  Prepare( 1, ComboBox1 );
  Prepare( 2, ComboBox2 );
  Prepare( 3, ComboBox3 );
  Prepare( 4, ComboBox4 );
  Step := 0;
  for I := 1 to 4 do
    DeadCount[ I ] := 0;
  lbDead1.Caption := '';
  lbDead2.Caption := '';
  lbDead3.Caption := '';
  lbDead4.Caption := '';
  lbStep.Caption := 'Step: 0';
  Timer1.Enabled := TRUE;
  PaintBox1.Invalidate;
end;

procedure TForm1.KOLForm1Destroy(Sender: PObj);
var I: Integer;
    D: TDirection;
begin
  Clear;
  BummIco.Free;
  for I := 1 to 4 do
  for D := Low(D) to High(D) do
  begin
    Sprites[ I, D ].Free;
  end;
end;

procedure TForm1.Clear;
var I, J: Integer;
begin
  for I := 1 to 4 do
    Free_And_Nil( ArmyProg[ I ] );
  for I := 1 to MaxSz do
  for J := 1 to MaxSz do
    Free_And_Nil( Desk[ I, J ] );
end;

procedure TForm1.Timer1Timer(Sender: PObj);
var I, J, K, N: Integer;
    R, R2: PRobot;
    S: PChar;
    P, P1: TPoint;
    RobCounts: array[ 1..4 ] of Integer;
begin
  //TRY

  Inc( Step );
  //     
  for I := 1 to MaxX do
  for J := 1 to MaxY do
  begin
    R := Desk[ I, J ];
    if R = nil then Continue;
    R.Energy := R.Energy + R.EnergyAdd;
    R.EnergyAdd := 0;
    R.Ready := FALSE;
    R.GoForward := FALSE;
    R.DoAttack := FALSE;
    K := 0; //   (1/100 )
    while K < 91 do
    begin
      S := R.CurrentCommand;
      if S = nil then
      begin
        Inc( K, 10 );
        R.InstructionPt := MakePoint( 0, 0 );
      end
      else
      begin
        CASE S^ OF
        'A': begin
               if K > 0 then break;
               R.DoAttack := TRUE;
               if R.Attack then R.SkipToSpc
                           else R.GotoLabel;
               Inc( K, 100 );
             end;
        'B': begin
               if K > 0 then break;
               R.Direction := BackDir[ R.Direction ];
               if R.AnyForward then R.GotoLabel
                                 else R.SkipToSpc;
               Inc( K, 100 );
             end;
        'C': begin
               R.CallStack.Add( Pointer( R.InstructionPt.Y ) );
               R.CallStack.Add( Pointer( R.InstructionPt.X ) );
               if R.CallStack.Count > 200 then
               begin
                 R.CallStack.Delete( 0 );
                 R.CallStack.Delete( 0 );
               end;
               R.GotoLabel;
               Inc( K, 10 );
             end;
        'D': begin
               if K > 75 then break;
               R.Check( R.Distance, S );
               Inc( K, 25 );
             end;
        'E': begin
               if K > 75 then break;
               R.Check( R.Energy, S );
               Inc( K, 25 );
             end;
        'F': begin
               if K > 0 then break;
               if R.AnyForward then begin Dec( R.Energy, 1 ); R.GotoLabel; end
                               else begin R.GoForward := TRUE; Inc( R.Energy, 2 ); end;
               R.SkipToSpc;
               Inc( K, 100 );
             end;
        'G': begin
               R.GotoLabel;
               Inc( K, 10 );
             end;
        'H': begin
               if K > 75 then break;
               R.LastMsgLabel := R.HeardLabel;
               R.LastMsgCoords := R.HeardCoord;
               if R.LastMsgLabel <> '' then
               begin
                 R.CallStack.Add( Pointer( R.InstructionPt.Y ) );
                 R.CallStack.Add( Pointer( R.InstructionPt.X ) );
                 if R.CallStack.Count > 200 then
                 begin
                   R.CallStack.Delete( 0 );
                   R.CallStack.Delete( 0 );
                 end;
                 R.GotoLabel( R.LastMsgLabel );
               end
               else R.GotoLabel;
               Inc( K, 25 );
             end;
        'I': begin
               if K > 75 then break;
               if R.EnemyForward
                 then R.GotoLabel
                 else R.SkipToSpc;
               Inc( K, 25 );
             end;
        'K': begin
               N := 0;
               while S^ in [ 'A'..'Z' ] do Inc( S );
               if S^ = '.' then Inc( S );
               if S^ in [ '0'..'9' ] then
                 N := GetNum( S );
               if N <= 0 then N := 1;
               while N > 0 do
               begin
                 if R.CallStack.Count > 1 then
                 begin
                   R.CallStack.Delete( R.CallStack.Count-1 );
                   R.CallStack.Delete( R.CallStack.Count-1 );
                 end
                   else
                 begin
                   R.GotoLabel;
                   break;
                 end;
                 Dec( N );
               end;
               if N = 0 then
                 R.SkipToSpc;
               Inc( K, 10 );
             end;
        'L': begin
               if K > 50 then break;
               R.Direction := LeftDir[ R.Direction ];
               if R.AnyForward then R.GotoLabel
                                 else R.SkipToSpc;
               Inc( K, 50 );
             end;
        'M': begin
               if K > 75 then break;
               R.Check( R.AllyCount, S );
               Inc( K, 25 );
             end;
        'N': begin
               if K > 75 then break;
               R.Check( R.EnemyCount, S );
               Inc( K, 25 );
             end;
        'O': begin
               if K > 75 then break;
               R.LastMsgCoords := R.PositionOnDesk;
               if R.AnyForward then R.GotoLabel
                               else R.SkipToSpc;
               Inc( K, 25 );
             end;
        'P': begin
               if K > 75 then break;
               Inc( R.Energy, 2 );
               if R.EnemyForward then R.GotoLabel
                                 else R.SkipToSpc;
               Inc( K, 100 );
             end;
        'Q': begin
               if R.CallStack.Count > 1 then
               begin
                 R.InstructionPt.X := Integer( R.CallStack.Items[ R.CallStack.Count-1 ] );
                 R.InstructionPt.Y := Integer( R.CallStack.Items[ R.CallStack.Count-2 ] );
                 R.CallStack.Delete( R.CallStack.Count-1 );
                 R.CallStack.Delete( R.CallStack.Count-1 );
               end;
               R.SkipToSpc;
               Inc( K, 10 );
             end;
        'R': begin
               if K > 50 then break;
               R.Direction := RightDir[ R.Direction ];
               if R.AnyForward then R.GotoLabel
                                 else R.SkipToSpc;
               Inc( K, 50 );
             end;
        'S': begin
               if K > 75 then break;
               R.SendMessage(S);
               Dec( R.Energy );
               Inc( K, 25 );
             end;
        'T': begin
               if K > 0 then break;
               if R.Transfer( S ) then R.SkipToSpc
                                  else R.GotoLabel;
               Inc( K, 100 );
             end;
        'W': begin
               if K > 0 then break;
               if R.HeardLabel <> '' then
                 R.TurnToHeard
                 else
               if Random( 1 ) = 0 then
                 R.Direction := LeftDir[ R.Direction ]
               else
                 R.Direction := RightDir[ R.Direction ];
               if R.AnyForward
                 then R.GotoLabel
                 else R.SkipToSpc;
               Inc( K, 100 );
             end;
        'X', 'Y', 'Z':
             begin
               if K > 75 then break;
               R.WorkWithVar( @ R.Vars[ S^ ], S );
               Inc( K, 25 );
             end;
        else begin
               R.SkipToSpc;
               Inc( K, 10 );
             end;
        END;
      end;
      if DebugRobot = R then
        AddCommandToDebugWnd( R.CurrentCommand, R );
    end;
    {if K < 75 then
    begin
      //    1/4   +1 :
      Inc( R.Energy, (100 - K) div 4 );
    end;}
  end;

  for I := 1 to 4 do RobCounts[ I ] := 0;
  {for I := 1 to MaxX do
  for J := 1 to MaxY do
  begin
    R := Desk[ I, J ];
    if R = nil then Continue;
    if R.Energy > 200 then
    begin
      P := PositionForward( MakePoint( I, J ), d_Left );
      R2 := Desk[ I, J ];
      if R2 <> nil then R2.EnergyAdd := -20;
      P := PositionForward( MakePoint( I, J ), d_Top );
      R2 := Desk[ I, J ];
      if R2 <> nil then R2.EnergyAdd := -20;
      P := PositionForward( MakePoint( I, J ), d_Right );
      R2 := Desk[ I, J ];
      if R2 <> nil then R2.EnergyAdd := -20;
      P := PositionForward( MakePoint( I, J ), d_Bottom );
      R2 := Desk[ I, J ];
      if R2 <> nil then R2.EnergyAdd := -20;
    end;
  end;}
  //      ,  ,  
  for I := 1 to MaxX do
  for J := 1 to MaxY do
  begin
    R := Desk[ I, J ];
    if R = nil then Continue;
    if (R.Energy < 0) {or (R.Energy > 200)} then
    begin
      Dec( DeadCount[ R.Army ] );
      if R = DebugRobot then
      begin
        AddCommandToDebugWnd( '-=RIP=-', R );
        DebugRobot := nil;
      end;
      R.Free;
      Desk[ I, J ] := nil;
      Continue;
    end
      else
    if R.Energy > 200 then
    begin
      R.Energy := 200;
    end;
    if R.Ready then Continue;
    R.Ready := TRUE;
    Inc( RobCounts[ R.Army ] );

    if R.GoForward and not R.AnyForward then
    begin
      P := MakePoint( I, J );
      P1 := PositionForward( P, R.Direction );
      Desk[ I, J ] := nil;
      Desk[ P1.X, P1.Y ] := R;
      if R.Energy >= 100 then
      begin
        new( R2, Create );
        R2.Ready := TRUE;
        R2.Army := R.Army;
        R2.Direction := R.Direction;
        N := R.Energy div 2;
        R.Energy := R.Energy - N;
        R2.Energy := N;
        R2.Vars := R.Vars;
        R2.LastMsgCoords := R.LastMsgCoords;
        R2.LastMsgLabel := R.LastMsgLabel;
        R2.HeardCoord := R.HeardCoord;
        R2.HeardLabel := R.HeardLabel;
        R2.ProgramText := R.ProgramText;
        {R2.InstructionPt := R.InstructionPt;
         for K := 0 to R.CallStack.Count-1 do
          R2.CallStack.Add(R2.CallStack.Items[ I ]);}
        Desk[ I, J ] := R2;
        Inc( RobCounts[ R.Army ] );
      end;
    end;
  end;

  lbCount1.Caption := Int2Str( RobCounts[ 1 ] );
  lbCount2.Caption := Int2Str( RobCounts[ 2 ] );
  lbCount3.Caption := Int2Str( RobCounts[ 3 ] );
  lbCount4.Caption := Int2Str( RobCounts[ 4 ] );
  if DeadCount[ 1 ] <> 0 then
    lbDead1.Caption := Int2Str( DeadCount[ 1 ] );
  if DeadCount[ 2 ] <> 0 then
    lbDead2.Caption := Int2Str( DeadCount[ 2 ] );
  if DeadCount[ 3 ] <> 0 then
    lbDead3.Caption := Int2Str( DeadCount[ 3 ] );
  if DeadCount[ 4 ] <> 0 then
    lbDead4.Caption := Int2Str( DeadCount[ 4 ] );
  lbStep.Caption := 'Step: ' + Int2Str( Step );

  PaintBox1.Invalidate;
  {EXCEPT
  on E: Exception do
  begin
    ShowMessage( E.Message );
    raise;
  end;
  END;}
end;

procedure TForm1.PaintBox1Paint(Sender: PControl; DC: HDC);
const
  Colors: array[ 1..4 ] of TColor = ( clRed, clNavy, clGreen, clBlue );
var I, J, X, Y, N: Integer;
    Bmp, Sprite: PBitmap;
    R: PRobot;
    Rect: TRect;
    P: TPoint;
begin
  //TRY

  Bmp := NewDIBBitmap( MaxX * 14 + 1, MaxY * 14 + 1, pf16bit );
  TRY
    Bmp.Canvas.Brush.Color := clSilver;
    Bmp.Canvas.FillRect( Bmp.BoundsRect );
    Bmp.Canvas.Brush.Color := clBlack;
    Bmp.Canvas.FrameRect( Bmp.BoundsRect );
    Bmp.Canvas.Brush.Color := clWhite;
    Bmp.Canvas.Pen.Color := clBlack;
    for I := 1 to MaxX do
    for J := 1 to MaxY do
    begin
      X := (I - 1) * 14 + 1;
      Y := (J - 1) * 14 + 1;
      Bmp.Canvas.MoveTo( X + 13, Y );
      Bmp.Canvas.LineTo( X + 13, Y + 13 );
      Bmp.Canvas.LineTo( X-1, Y + 13 );
      R := Desk[ I, J ];
      if R <> nil then
      begin
        if DebugRobot = R then
        begin
          Bmp.Canvas.Brush.Color := clYellow;
          Bmp.Canvas.FillRect( MakeRect( X-1, Y-1, X + 15, Y + 15 ) );
        end;
        Sprite := Sprites[ R.Army, R.Direction ];
        {if Sprite.Empty then
        asm
          int 3
        end;}
        //Sprite.SaveToFile( GetStartDir + 'test5.bmp' );
        Sprite.Draw( Bmp.Canvas.Handle, X + 1, Y + 1 );
        N := Min( 100, R.Energy ) * 9 div 100;
        CASE R.Direction OF
        d_Left  : Rect := MakeRect( 11-N, 3, 11, 10 );
        d_Top   : Rect := MakeRect( 3, 11-N, 10, 11 );
        d_Right : Rect := MakeRect( 2, 3, N+1, 10 );
        d_Bottom: Rect := MakeRect( 3, 2, 11, 2+N );
        END;
        OffsetRect( Rect, X, Y );
        Bmp.Canvas.Brush.Color := Colors[ R.Army ];
        Bmp.Canvas.FillRect( Rect );
      end;
    end;
    for I := 1 to MaxX do
    for J := 1 to MaxY do
    begin
      R := Desk[ I, J ];
      if (R <> nil) and R.DoAttack then
      begin
        P := PositionForward( MakePoint( I, J ), R.Direction );
        X := (P.X - 1) * 14;
        Y := (P.Y - 1) * 14;
        BummIco.Draw( Bmp.Canvas.Handle, X - 1, Y - 1 );
      end;
    end;
    X := (PaintBox1.Width - MaxX * 14) div 2;
    Y := (PaintBox1.Height - MaxY * 14) div 2;
    Bmp.Draw( DC, X, Y );
    if Bmp.Width < PaintBox1.Width then
    begin
      PaintBox1.Canvas.FillRect( MakeRect( X + Bmp.Width, 0, PaintBox1.Width, PaintBox1.Height ) );
      PaintBox1.Canvas.FillRect( MakeRect( 0, 0, X, PaintBox1.Height ) );
    end;
    if Bmp.Height < PaintBox1.Height then
    begin
      PaintBox1.Canvas.FillRect( MakeRect( 0, Y + Bmp.Height, PaintBox1.Width, PaintBox1.Height ) );
      PaintBox1.Canvas.FillRect( MakeRect( 0, 0, PaintBox1.Width, Y ) );
    end;
  FINALLY
    Bmp.Free;
  END;

  {EXCEPT
  on E: Exception do
  begin
    ShowMessage( E.Message );
    raise;
  end;
  END;}
end;

procedure TForm1.Init_Sprites;
var I: Integer;
    Bmp, Bmp1: PBitmap;
begin
  for I := 1 to 4 do
  begin
    Bmp := NewBitmap( 0, 0 );
    Bmp.LoadFromResourceName( HInstance, PChar( 'ROBOT' + Int2Str( I ) ) );
    Bmp1 := NewDIBBitmap( Bmp.Width, Bmp.Height, pf16bit );
    Bmp.Draw( Bmp1.Canvas.Handle, 0, 0 );
    Sprites[ I, d_Left ] := Bmp1;
    if Bmp1.Empty then
    asm
      int 3
    end;
    //Bmp1.SaveToFile( GetStartDir + 'test1.bmp' );
    Bmp.Free;
    Bmp := Bmp1;
    Bmp1 := NewDIBBitmap( Bmp.Width, Bmp.Height, pf16bit );
    Bmp1.Assign( Bmp );
    Bmp1.PixelFormat := pf16bit;
    Bmp1.RotateRight;
    Sprites[ I, d_Top ] := Bmp1;
    if Bmp1.Empty then
    asm
      int 3
    end;
    Bmp := Bmp1;
    //Bmp.SaveToFile( GetStartDir + 'test2.bmp' );
    Bmp1 := NewDIBBitmap( Bmp.Width, Bmp.Height, pf16bit );
    Bmp1.Assign( Bmp );
    Bmp1.PixelFormat := pf16bit;
    Bmp1.RotateRight;
    Sprites[ I, d_Right ] := Bmp1;
    if Bmp1.Empty then
    asm
      int 3
    end;
    Bmp := Bmp1;
    //Bmp.SaveToFile( GetStartDir + 'test3.bmp' );
    Bmp1 := NewDIBBitmap( Bmp.Width, Bmp.Height, pf16bit );
    Bmp1.Assign( Bmp );
    Bmp1.PixelFormat := pf16bit;
    Bmp1.RotateRight;
    Sprites[ I, d_Bottom ] := Bmp1;
    if Bmp1.Empty then
    asm
      int 3
    end;
    //Bmp := Bmp1;
    //Bmp.SaveToFile( GetStartDir + 'test4.bmp' );
  end;
  BummIco := NewIcon;
  BummIco.LoadFromResourceName( HInstance, 'BUMM', 16 );
end;

procedure TForm1.RadioBox1Click(Sender: PObj);
begin
  if RadioBox1.Checked then Timer1.Interval := 1000
  else
  if RadioBox2.Checked then Timer1.Interval := 200
  else
  if RadioBox3.Checked then Timer1.Interval := 50;
end;

procedure TForm1.PaintBox1Click(Sender: PObj);
var P: TPoint;
    I, J: Integer;
    R: PRobot;
begin
  GetCursorPos( P );
  P := PControl( Sender ).Screen2Client( P );
  I := (P.X - (PaintBox1.Width - MaxX * 14) div 2) div 14 + 1;
  J := (P.Y - (PaintBox1.Height - MaxY * 14) div 2) div 14 + 1;
  if (I < 1) or (I > MaxX) then Exit;
  if (J < 1) or (J > MaxY) then Exit;
  R := Desk[ I, J ];
  if R = nil then Exit;

  if DebugRobot = R then Exit;
  DebugRobot := R;
  lbDebug1.Caption := '';
  lbDebug2.Caption := '';
  lbDebug3.Caption := '';
  lbDebug4.Caption := '';
  lbDebug5.Caption := '';
  lbDebug6.Caption := '';
  lbDebug7.Caption := '';
  AddCommandToDebugWnd( R.CurrentCommand, R );

  PaintBox1.Invalidate;
end;

procedure TForm1.AddCommandToDebugWnd(S: PChar; R: PRobot);
var Cmd: String;
    I: Integer;
begin
  Cmd := S;
  I := pos( ' ', Cmd );
  if I > 0 then
    Cmd := Copy( Cmd, 1, I - 1 );
  I := pos( '*', Cmd );
  if I > 0 then
    Cmd := Copy( Cmd, 1, I - 1 );
  lbDebug1.Caption := lbDebug2.Caption;
  lbDebug2.Caption := lbDebug3.Caption;
  lbDebug3.Caption := lbDebug4.Caption;
  lbDebug4.Caption := lbDebug5.Caption;
  lbDebug5.Caption := lbDebug6.Caption;
  lbDebug6.Caption := lbDebug7.Caption;
  lbDebug7.Caption := Cmd;

  lbDbgX.Caption := 'X:' + Int2Str( R.Vars[ 'X' ] );
  lbDbgY.Caption := 'Y:' + Int2Str( R.Vars[ 'Y' ] );
  lbDbgZ.Caption := 'Z:' + Int2Str( R.Vars[ 'Z' ] );
  lbDbgE.Caption := 'E:' + Int2Str( R.Energy );
  lbDbgD.Caption := 'D:' + Int2Str( R.Distance );
  lbDbgN.Caption := 'N:' + Int2Str( R.EnemyCount );
  lbDbgM.Caption := 'M:' + Int2Str( R.AllyCount );
end;

procedure TForm1.btPauseClick(Sender: PObj);
begin
  btPause.Enabled := FALSE;
  btStep.Enabled := TRUE;
  btRun.Enabled := TRUE;
  Timer1.Enabled := FALSE;
end;

procedure TForm1.btStepClick(Sender: PObj);
begin
  Timer1Timer( Timer1 );
end;

procedure TForm1.btRunClick(Sender: PObj);
begin
  btPause.Enabled := TRUE;
  btStep.Enabled := FALSE;
  btRun.Enabled := FALSE;
  Timer1.Enabled := TRUE;
end;

procedure TForm1.KOLForm1Close(Sender: PObj; var Accept: Boolean);
begin
  Timer1.Enabled := FALSE;
end;

procedure TForm1.BitBtn1Click(Sender: PObj);
begin
  ShowMessage( 'AutoWar v2.3 (C) by Vladimir Kladov, 1995, 2003'#13#10#13#10 +
               'http://bonanzas.rinet.ru'#13#10 +
               'http://xcl.cjb.net' );
end;

begin
    UseDelphiMemoryManager;

end.


